#include "dialog.inc"

DATA SECTION

ALIGN 04h
hInstance DD ?
CommandLine DD ?

ALIGN 01h
DlgName DB "MyDialog",0
AppName DB "Our Second Dialog Box",0
TestString DB "Wow! I'm in an edit box now",0
buffer DB 512 DUP ?

CODE SECTION

START:
	invoke GetModuleHandle, NULL
	mov    [hInstance],eax
	invoke DialogBoxParam,[hInstance],ADDR DlgName,NULL,ADDR DlgProc,NULL
	nop
	invoke ExitProcess,eax

DlgProc FRAME hWnd, uMsg, wParam, lParam
	USES EDX,EDI,ESI
	
	nop
	cmp D[uMsg],WM_INITDIALOG
	jne >.WM_CLOSE
		nop
		invoke GetDlgItem, [hWnd],IDC_EDIT
		invoke SetFocus,eax
		jmp LONG >.exit

.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.WM_COMMAND
		invoke SendMessage,[hWnd],WM_COMMAND,IDM_EXIT,0
		jmp LONG >.exit

.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne LONG >.NOT_PROCESSED
		mov eax,[wParam]
		cmp D[lParam],0
		jne >.BUTTONS
			cmp ax,IDM_GETTEXT
			jne >.IDM_CLEAR
				invoke GetDlgItemText,[hWnd],IDC_EDIT,ADDR buffer,512
				invoke MessageBox,NULL,ADDR buffer,ADDR AppName,MB_OK
				jmp >.END_MENU
		
		.IDM_CLEAR
			cmp ax,IDM_CLEAR
			jne >.IDM_EXIT
				invoke SetDlgItemText,[hWnd],IDC_EDIT,NULL
				jmp >.END_MENU
		
		.IDM_EXIT
			cmp ax,IDM_EXIT
			jne >.END_MENU
				invoke EndDialog,[hWnd],NULL
	.END_MENU
		jmp >.END_BUTTONS
	
	.BUTTONS
		mov edx,D[wParam]
		shr edx,16
		cmp dx,BN_CLICKED
		jne >.END_BUTTONS
			cmp ax,IDC_BUTTON
			jne >.IDC_EXIT
				invoke SetDlgItemText,[hWnd],IDC_EDIT,ADDR TestString
				jmp >.END_BUTTONS
                       
                       .IDC_EXIT
	                       	cmp ax,IDC_EXIT
	               	jne >.END_BUTTONS
			invoke SendMessage,[hWnd],WM_COMMAND,IDM_EXIT,0
	.END_BUTTONS
		jmp >.exit

.NOT_PROCESSED
		mov eax,FALSE
		ret

.exit
	mov eax,TRUE
	ret
	
DlgProc ENDF